/**
 * URL 下拉框，根据URL加载下拉选项
 * 
 * 
 */
(function(){
	
	function InitSelectPicker($element, options){
		var curValueMap = getCurSelectValues($element, options);
		var change = options['onchange'];
		if (change){
			$element.attr('onchange', change);
		}
		var multiple = $element.attr('multiple');
		if (!multiple){
			multiple = options['multiple'] ? options['multiple'] : false;
		}
		var defaultText = options['defaultText'] ? options['defaultText'] : "请选择";
		var defaultShow = options['defaultShow'] ? options['defaultShow'] : true;
		
		if(options && options['url']){
			//异步请求 URL，获取下拉框选项
			$.ajax({
				url: options['url'],
				type: "POST",
				//改为同步，否则导致二级级联框出问题
				async: false,
				dataType: "json",
				success: function(datas){
					if(datas && datas.length>0){
						//加载返回的数据
						var html = "";
						if(!multiple && defaultShow){
							html += "<option value=\"\" " + ((!curValueMap) ? "selected=\"true\" " : "") + ">"
									+ defaultText + "</option>";
						}
						for(var i = 0; i < datas.length; i++){
							var data = datas[i];
							html += "<option value=\"" + data['key'] + "\" "
								+ (curValueMap[data['key']] ? "selected=\"true\" " : "")
								+ ">" + data['value'] + "</option>";
							
						}
						$element.empty();
						$element.append(html);
						$element.selectpicker('refresh');
					}else{
						var html = "";
						if(!multiple && defaultShow){
							html += "<option value=\"\" " + ((!curValueMap) ? "selected=\"true\" " : "") + ">"
									+ defaultText + "</option>";
						}
						
						$element.append(html);
						$element.selectpicker('refresh');
					}
				},error: function(e){
					
				}
			});
		}
		var liveSearch = options['liveSearch'] ? options['liveSearch'] : false;
		
		
		
		var params = {
				noneSelectedText: defaultText,
				size: 6,
				selectedTextFormat: "count>3",
				countSelectedText: function (numSelected, numTotal) {
					return "已选择 {0} 项";
				}
		};
		
		if(liveSearch){
			params['liveSearch'] = true;
			params['liveSearchPlaceholder'] = "请输入搜索内容";
		}
		
		$element.selectpicker(params);
		
	}
	
	
	//获取当前选中的列表
	function getCurSelectValues($element, options){
		var curValues = options['curValues'] ? options['curValues'] : "";
		var multiple = options['multiple'] ? options['multiple'] : false;
		var curValueMap = {};
		
		if(curValues){
			if(multiple){
				var curValueList  = curValues.split(/[ ;,]/gi);
				var length = curValueList.length;
				
				for(var i = 0; i < length; i++){
					curValueMap[curValueList[i]] = true;
				}
			}else{
				curValueMap[curValues] = true;
			}
		}
		
		return curValueMap;
	}
	
	//添加到jquery插件中
	$.fn.initselectpicker = function(options){
		new InitSelectPicker($(this), options);
	}
})(jQuery)