/**
 * URL 下拉框，根据URL加载下拉选项
 * 
 * 
 */
(function(){
	
	function UrlSelectPicker($element, options){
		var append = true;
		
		if($($element).is("div") || $($element).is("span")){
			append = false;
		}
		
		var items = [];
		
		if(options && options['url']){
			//异步请求 URL，获取下拉框选项
			$.ajax({
				url: options['url'],
				type: "POST",
				dataType: "json",
				async:false,
				success: function(datas){
					if(datas && datas.length>0){
						//加载返回的数据
						for(var i = 0; i < datas.length; i++){
							var data = datas[i];
							items.push({"id": data['key'], "name": data['value']});
						}
					}
				},error: function(e){
					
				}
			});
		}
		var selectId = getSelectId($element, options);
		var selectName = options['selectName'] ? options['selectName'] : "";
		var curValueMap = getCurSelectValues(options);
		var defaultText = options['defaultText'] ? options['defaultText'] : "请选择";
		var widthVal = options['widthVal'] ? options['widthVal'] : "150px";
		var multiple = options['multiple'] ? options['multiple'] : false;
		var liveSearch = options['liveSearch'] ? options['liveSearch'] : false;
		var defaultShow = options['defaultShow'] ? options['defaultShow'] : true;
		
		var html = "<select id=\"" + selectId + "\" name=\"" + selectName + "\" "
					+ (multiple ? "multiple " : "")
					+ (options['onchange'] ? ("onchange=\"" + options['onchange'] + "\"") : "")
					+ "style='width:" + widthVal + "'"
					+ (options['validate'] ? " " + options['validate'] : "")
					+ ">";
	
		if(!multiple && defaultShow){
			html += "<option value=\"\" " + ((!curValueMap) ? "selected=\"true\" " : "") + ">"
					+ defaultText + "</option>";
		}
		
		for(var i = 0; i < items.length; i++){
			var item = items[i];
			html += "<option value=\"" + item['id'] + "\" "
					+ (curValueMap[item['id']] ? "selected=\"true\" " : "")
					+ ">" + item['name'] + "</option>";
		}
	
		html += "</select>";
		
		//html添加到页面
		if(append){
			$(html).insertAfter($element);
		}else{
			$($element).empty();
			$(html).appendTo($element);
		}
		
		var params = {
				noneSelectedText: defaultText,
				size: 6,
				selectedTextFormat: "count>3",
				countSelectedText: function (numSelected, numTotal) {
					return "已选择 {0} 项";
				}
		};
		
		if(widthVal){
			params['width'] = widthVal;
		}
		
		if(liveSearch){
			params['liveSearch'] = true;
			params['liveSearchPlaceholder'] = "请输入搜索内容";
		}
		
		$("#" + selectId).selectpicker(params);
		
//		$("#" + selectId).selectpicker({
//			noneSelectedText: defaultText,
//			size: 6,
//			selectedTextFormat: "count>3",
//			countSelectedText: function (numSelected, numTotal) {
//				return "已选择 {0} 项";
//			}
//		});
	}
	
	//获取下拉框的Id
	function getSelectId($element, options){
		if(options['selectId']) return options['selectId'];
		
		if($($element).attr("id")) return $($element).attr("id") + "select";
		
		return "select" + new Date().getTime();
	}
	
	//获取当前选中的列表
	function getCurSelectValues(options){
		var curValues = options['curValues'] ? options['curValues'] : "2";
		var multiple = options['multiple'] ? options['multiple'] : false;
		var curValueMap = {};
		
		if(curValues){
			if(multiple){
				var curValueList  = curValues.split(/[ ;,]/gi);
				var length = curValueList.length;
				
				for(var i = 0; i < length; i++){
					curValueMap[curValueList[i]] = true;
				}
			}else{
				curValueMap[curValues] = true;
			}
		}
		
		return curValueMap;
	}
	
	//添加到jquery插件中
	$.fn.urlselectpicker = function(options){
		new UrlSelectPicker($(this), options);
	}
})(jQuery)